Index: issm/trunk/src/m/classes/clusters/generic.m
===================================================================
--- issm/trunk/src/m/classes/clusters/generic.m	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/generic.m	(revision 26744)
@@ -4,4 +4,9 @@
 %      cluster=generic('name','astrid','np',3);
 %      cluster=generic('name',oshostname(),'np',3,'login','username');
+%
+%   TODO:
+%   - Add support for restart to Windows (under MSYS2), then activate tests 125 
+%   and 126 in test suite
+%
 
 classdef generic
@@ -28,5 +33,5 @@
 
 			%Change the defaults if ispc
-			if ispc,
+			if ispc & ~ismingw,
 				cluster.codepath      = [issmdir() '\bin'];
 				cluster.etcpath       = [issmdir() '\etc'];
@@ -65,4 +70,8 @@
 		end
 		%}}}
+		function numprocs=nprocs(cluster) % {{{
+			numprocs=cluster.np;
+		end
+		%}}}
 		function md = checkconsistency(cluster,md,solution,analyses) % {{{
 			if cluster.np<1
@@ -139,13 +148,14 @@
 				fprintf(fid,'@echo off\n');
 
-				if IssmConfig('_HAVE_PETSC_MPI_'),
-					warning('parallel runs not allowed yet in Windows. Defaulting to 1 cpus');
-					cluster.np=1;
-				end
+				% if IssmConfig('_HAVE_PETSC_MPI_'),
+				% 	warning('parallel runs not allowed yet in Windows. Defaulting to 1 cpus');
+				% 	cluster.np=1;
+				% end
 
 				if cluster.np>1,
-					fprintf(fid,'"C:\\Program Files\\MPICH2\\bin\\mpiexec.exe" -n %i "%s/%s" %s ./ %s ',cluster.np,cluster.codepath,executable,solution,modelname);
-				else
-					fprintf(fid,'"%s/%s" %s ./ %s ',cluster.codepath,executable,solution,modelname);
+					% fprintf(fid,'"C:\\Program Files\\MPICH2\\bin\\mpiexec.exe" -n %i "%s/%s" %s ./ %s',cluster.np,cluster.codepath,executable,solution,modelname);
+					fprintf(fid,'"C:\\Program Files\\Microsoft MPI\\Bin\\mpiexec.exe" -n %i "%s/%s" %s ./ %s',cluster.np,cluster.codepath,executable,solution,modelname);
+				else
+					fprintf(fid,'"%s/%s" %s ./ %s',cluster.codepath,executable,solution,modelname);
 				end
 				fclose(fid);
@@ -165,5 +175,5 @@
 
 			%what is the executable being called?
-			executable='issm_slr.exe';
+			executable='issm_slc.exe';
 
 			if ispc(), error('BuildQueueScriptMultipleModels not support yet on windows machines');end;
@@ -280,5 +290,5 @@
 		end
 		%}}}
-		function UploadQueueJob(cluster,modelname,dirname,filelist)% {{{
+		function UploadQueueJob(cluster,modelname,dirname,filelist) % {{{
 
 			if ~ispc,
@@ -301,8 +311,7 @@
 			end
 		end %}}}
-		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch)% {{{
+		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch) % {{{
 
 			if ~ispc,
-
 				%figure out what shell extension we will use:
 				if isempty(strfind(cluster.shell,'csh')),
@@ -318,8 +327,8 @@
 				else
 					if ~batch,
-					launchcommand=['source ' cluster.etcpath '/environment.' shellext ' && cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+						launchcommand=['source ' cluster.etcpath '/environment.' shellext ' && cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
 						' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && source  ' modelname '.queue '];
 					else
-					launchcommand=['source ' cluster.etcpath '/environment.' shellext ' && cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+						launchcommand=['source ' cluster.etcpath '/environment.' shellext ' && cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
 						' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz '];
 					end
@@ -331,5 +340,5 @@
 
 		end %}}}
-		function LaunchQueueJobIceOcean(cluster,modelname,dirname,filelist,restart,batch)% {{{
+		function LaunchQueueJobIceOcean(cluster,modelname,dirname,filelist,restart,batch) % {{{
 
 			if ~ispc,
@@ -360,5 +369,5 @@
 
 		end %}}}
-		function Download(cluster,dirname,filelist)% {{{
+		function Download(cluster,dirname,filelist) % {{{
 
 			if ispc(),
Index: issm/trunk/src/m/classes/clusters/generic.py
===================================================================
--- issm/trunk/src/m/classes/clusters/generic.py	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/generic.py	(revision 26744)
@@ -1,12 +1,12 @@
-from socket import gethostname
 from subprocess import call
 
-import numpy as np
-
+from fielddisplay import fielddisplay
+from helpers import *
 try:
     from generic_settings import generic_settings
 except ImportError:
-    print('Warning generic_settings.py not found, default will be used')
-from MatlabFuncs import ispc
+    #print('Warning: generic.py: generic_settings.py not found, default will be used')
+    pass
+from MatlabFuncs import *
 from IssmConfig import IssmConfig
 from issmdir import issmdir
@@ -39,36 +39,40 @@
         self.shell = '/bin/sh'
 
-        #use provided options to change fields
+        # Use provided options to change fields
         options = pairoptions(*args)
 
-        #get name
-        self.name = gethostname()
-
-        #initialize cluster using user settings if provided
-
+        # Get name
+        self.name = oshostname()
+
+        # Initialize cluster using user settings if provided
         try:
             self = generic_settings(self)
         except NameError:
-            print("generic_settings.py not found, using default settings")
-
-        #OK get other fields
+            # print('generic_settings.py not found, using default settings')
+            pass
+
+        # OK get other fields
         self = options.AssignObjectFields(self)
     # }}}
 
     def __repr__(self):  # {{{
-        #  display the object
-        s = "class '%s' object '%s' = \n" % (type(self), 'self')
-        s += "    name: %s\n" % self.name
-        s += "    login: %s\n" % self.login
-        s += "    np: %i\n" % self.np
-        s += "    port: %i\n" % self.port
-        s += "    codepath: %s\n" % self.codepath
-        s += "    executionpath: %s\n" % self.executionpath
-        s += "    valgrind: %s\n" % self.valgrind
-        s += "    valgrindlib: %s\n" % self.valgrindlib
-        s += "    valgrindsup: %s\n" % self.valgrindsup
-        s += "    verbose: %s\n" % self.verbose
-        s += "    shell: %s\n" % self.shell
+        # Display the object
+        s = 'class \'{}\' object \'{}\' = \n'.format(type(self), 'self')
+        s += '    name: {}\n'.format(self.name)
+        s += '    login: {}\n'.format(self.login)
+        s += '    np: {}\n'.format(self.np)
+        s += '    port: {}\n'.format(self.port)
+        s += '    codepath: {}\n'.format(self.codepath)
+        s += '    executionpath: {}\n'.format(self.executionpath)
+        s += '    valgrind: {}\n'.format(self.valgrind)
+        s += '    valgrindlib: {}\n'.format(self.valgrindlib)
+        s += '    valgrindsup: {}\n'.format(self.valgrindsup)
+        s += '    verbose: {}\n'.format(self.verbose)
+        s += '    shell: {}\n'.format(self.shell)
         return s
+    # }}}
+
+    def nprocs(self):  # {{{
+        return self.np
     # }}}
 
@@ -179,5 +183,5 @@
             fid.close()
 
-        #in interactive mode, create a run file, and errlog and outlog file
+        # In interactive mode, create a run file, and errlog and outlog file
         if self.interactive:
             fid = open(modelname + '.errlog', 'w')
@@ -188,5 +192,5 @@
 
     def UploadQueueJob(self, modelname, dirname, filelist):  # {{{
-        #compress the files into one zip.
+        # Compress the files into one zip
         compressstring = 'tar -zcf {}.tar.gz '.format(dirname)
         for file in filelist:
@@ -203,5 +207,5 @@
     def LaunchQueueJob(self, modelname, dirname, filelist, restart, batch):  # {{{
         print('launching solution sequence on remote cluster')
-        if restart:
+        if not isempty(restart):
             launchcommand = 'cd {} && cd {} chmod 755 {}.queue && ./{}.queue'.format(self.executionpath, dirname, modelname, modelname)
         else:
@@ -215,7 +219,7 @@
     def Download(self, dirname, filelist):  # {{{
         if ispc():
-            #do nothing
+            # Do nothing
             return
-        #copy files from cluster to current directory
+        # Copy files from cluster to current directory
         directory = '{}/{}/'.format(self.executionpath, dirname)
         issmscpin(self.name, self.login, self.port, directory, filelist)
Index: issm/trunk/src/m/classes/clusters/generic_static.m
===================================================================
--- issm/trunk/src/m/classes/clusters/generic_static.m	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/generic_static.m	(revision 26744)
@@ -36,4 +36,6 @@
 			disp(sprintf('    np: %i',cluster.np));
 			disp(sprintf('    codepath: %s',cluster.codepath));
+			disp(sprintf('    executionpath: %s',cluster.executionpath));
+			disp(sprintf('    interactive: %s',cluster.interactive));
 			disp(sprintf('    shell: %s',cluster.shell));
 		end
@@ -84,9 +86,9 @@
 		end
 		%}}}
-		function UploadQueueJob(cluster,modelname,dirname,filelist)% {{{
+		function UploadQueueJob(cluster,modelname,dirname,filelist) % {{{
 			% Do nothing
 			return;
 		end %}}}
-		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch)% {{{
+		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch) % {{{
 			if ~ispc,
 				% Figure out which file extension to use
@@ -104,5 +106,5 @@
 			end
 		end %}}}
-		function Download(cluster,dirname,filelist)% {{{
+		function Download(cluster,dirname,filelist) % {{{
 			% Do nothing
 			return;
Index: issm/trunk/src/m/classes/clusters/generic_static.py
===================================================================
--- issm/trunk/src/m/classes/clusters/generic_static.py	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/generic_static.py	(revision 26744)
@@ -1,9 +1,6 @@
 import math
 import os
-import socket
 import subprocess
-
 import numpy as np
-
 from IssmConfig import IssmConfig
 from issmdir import issmdir
@@ -11,14 +8,13 @@
 from issmscpin import issmscpin
 from issmscpout import issmscpout
-import MatlabFuncs as m
+from MatlabFuncs import *
 from pairoptions import pairoptions
 
 
 class generic_static(object):
-    """
-    GENERIC cluster class definition
+    """GENERIC cluster class definition
 
-       Usage:
-          cluster = generic_static('name', 'astrid', 'np', 3)
+    Usage:
+        cluster = generic_static('name', 'astrid', 'np', 3)
     """
 
@@ -38,5 +34,5 @@
 
         #get name
-        self.name = socket.gethostname()
+        self.name = oshostname()
 
         #initialize cluster using user settings if provided
Index: issm/trunk/src/m/classes/clusters/greenplanet.m
===================================================================
--- issm/trunk/src/m/classes/clusters/greenplanet.m	(revision 25994)
+++ issm/trunk/src/m/classes/clusters/greenplanet.m	(revision 26744)
@@ -1,3 +1,3 @@
-%PFE class definition
+%GREENPLANET cluster class definition
 %
 %   Usage:
@@ -7,163 +7,171 @@
 
 classdef greenplanet
-    properties (SetAccess=public)  
-		 % {{{
-		 name          = 'greenplanet'
-		 login         = '';
-		 numnodes      = 20;
-		 cpuspernode   = 8;
-		 port          = 8000;
-		 queue         = 'c6145';
-		 codepath      = '';
-		 executionpath = '';
-		 interactive   = 0;
-		 time          = 24*60;
-		 memory        = 2;
-	 end
-	 %}}}
-	 methods
-		 function cluster=greenplanet(varargin) % {{{
+	properties (SetAccess=public)
+		% {{{
+		name          = 'greenplanet'
+		login         = '';
+		numnodes      = 20;
+		cpuspernode   = 8;
+		port          = 8000;
+		queue         = 'c6145';
+		codepath      = '';
+		executionpath = '';
+		interactive   = 0;
+		time          = 24*60;
+		memory        = 2;
+	end
+	%}}}
+	methods
+		function cluster=greenplanet(varargin) % {{{
 
-			 %initialize cluster using default settings if provided
-			 if (exist('greenplanet_settings')==2), greenplanet_settings; end
+			%initialize cluster using default settings if provided
+			if (exist('greenplanet_settings')==2), greenplanet_settings; end
 
-			 %use provided options to change fields
-			 cluster=AssignObjectFields(pairoptions(varargin{:}),cluster);
-		 end
-		 %}}}
-		 function disp(cluster) % {{{
-			 %  display the object
-			 disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
-			 disp(sprintf('    name: %s',cluster.name));
-			 disp(sprintf('    login: %s',cluster.login));
-			 disp(sprintf('    port: %i',cluster.port));
-			 disp(sprintf('    numnodes: %i',cluster.numnodes));
-			 disp(sprintf('    cpuspernode: %i',cluster.cpuspernode));
-			 disp(sprintf('    np: %i',cluster.cpuspernode*cluster.numnodes));
-			 disp(sprintf('    queue: %s',cluster.queue));
-			 disp(sprintf('    codepath: %s',cluster.codepath));
-			 disp(sprintf('    executionpath: %s',cluster.executionpath));
-			 disp(sprintf('    interactive: %i',cluster.interactive));
-			 disp(sprintf('    time: %i',cluster.time));
-			 disp(sprintf('    memory: %i',cluster.memory));
-		 end
-		 %}}}
-		 function numprocs=np(cluster) % {{{
-			 %compute number of processors
-			 numprocs=cluster.numnodes*cluster.cpuspernode;
-		 end
-		 %}}}
-		 function md = checkconsistency(cluster,md,solution,analyses) % {{{
+			%use provided options to change fields
+			cluster=AssignObjectFields(pairoptions(varargin{:}),cluster);
+		end
+		%}}}
+		function disp(cluster) % {{{
+			%  display the object
+			disp(sprintf('class ''%s'' object ''%s'' = ',class(cluster),inputname(1)));
+			disp(sprintf('    name: %s',cluster.name));
+			disp(sprintf('    login: %s',cluster.login));
+			disp(sprintf('    numnodes: %i',cluster.numnodes));
+			disp(sprintf('    cpuspernode: %i',cluster.cpuspernode));
+			disp(sprintf('    np: %i',cluster.nprocs()));
+			disp(sprintf('    port: %i',cluster.port));
+			disp(sprintf('    queue: %s',cluster.queue));
+			disp(sprintf('    codepath: %s',cluster.codepath));
+			disp(sprintf('    executionpath: %s',cluster.executionpath));
+			disp(sprintf('    interactive: %i',cluster.interactive));
+			disp(sprintf('    time: %i',cluster.time));
+			disp(sprintf('    memory: %i',cluster.memory));
+		end
+		%}}}
+		function numprocs=nprocs(cluster) % {{{
+			%compute number of processors
+			numprocs=cluster.numnodes*cluster.cpuspernode;
+		end
+		%}}}
+		function md = checkconsistency(cluster,md,solution,analyses) % {{{
 
-			 available_queues={'c6145','ilg2.3','default'};
-			 queue_requirements_time=[Inf Inf];
-			 queue_requirements_np=[80 80];
+			available_queues={'brd2.4','has2.5','ilg2.3','m-c1.9','m-c2.2','nes2.8','sib2.9','m2090','default'};
+			queue_requirements_time=[Inf Inf Inf Inf Inf Inf Inf Inf Inf];
+			queue_requirements_np=[80 80 80 80 80 80 80 80 80];
 
-			 QueueRequirements(available_queues,queue_requirements_time,queue_requirements_np,cluster.queue,cluster.np,1)
+			QueueRequirements(available_queues,queue_requirements_time,queue_requirements_np,cluster.queue,cluster.nprocs(),1)
 
-			 %Miscelaneous
-			 if isempty(cluster.login), md = checkmessage(md,'login empty'); end
-			 if isempty(cluster.codepath), md = checkmessage(md,'codepath empty'); end
-			 if isempty(cluster.executionpath), md = checkmessage(md,'executionpath empty'); end
+			%Miscellaneous
+			if isempty(cluster.login), md = checkmessage(md,'login empty'); end
+			if isempty(cluster.codepath), md = checkmessage(md,'codepath empty'); end
+			if isempty(cluster.executionpath), md = checkmessage(md,'executionpath empty'); end
 
-		 end
-		 %}}}
-		 function BuildKrigingQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof,isdakota,isoceancoupling) % {{{
+		end
+		%}}}
+		function BuildKrigingQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof,isdakota,isoceancoupling) % {{{
 
-			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
-			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
+			if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
+			if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
 
-			 %write queuing script 
-			 fid=fopen([modelname '.queue'],'w');
-			 fprintf(fid,'#!/bin/bash\n');
-			 fprintf(fid,'#SBATCH --job-name=%s\n',modelname);
-			 fprintf(fid,'#SBATCH -p %s \n',cluster.queue);
-			 fprintf(fid,'#SBATCH -N %i -n %i\n',cluster.numnodes,cluster.cpuspernode);
-			 fprintf(fid,'#SBATCH --time=%i\n',cluster.time*60); %walltime is in seconds.
-			 fprintf(fid,'#SBATCH --mem-per-cpu=%igb\n',cluster.memory);
-			 fprintf(fid,'#SBATCH -o %s.outlog \n',modelname);
-			 fprintf(fid,'#SBATCH -e %s.errlog \n\n',modelname);
-			 fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath); %FIXME
-			 fprintf(fid,'source $ISSM_DIR/etc/environment.sh\n');       %FIXME
-			 fprintf(fid,'cd %s/%s\n\n',cluster.executionpath,dirname);
-			 fprintf(fid,'mpiexec -np %i %s/kriging.exe %s %s\n',cluster.np,cluster.codepath,[cluster.executionpath '/' modelname],modelname);
-			 if ~io_gather, %concatenate the output files:
-				 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
-			 end
-			 fclose(fid);
-		 end
-		 %}}}
-		 function BuildQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof,isdakota,isoceancoupling) % {{{
+			%write queuing script 
+			fid=fopen([modelname '.queue'],'w');
+			fprintf(fid,'#!/bin/bash\n');
+			fprintf(fid,'#SBATCH --job-name=%s\n',modelname);
+			fprintf(fid,'#SBATCH -p %s \n',cluster.queue);
+			fprintf(fid,'#SBATCH -N %i -n %i\n',cluster.numnodes,cluster.cpuspernode);
+			fprintf(fid,'#SBATCH --time=%i\n',cluster.time*60); %walltime is in seconds.
+			fprintf(fid,'#SBATCH --mem-per-cpu=%igb\n',cluster.memory);
+			fprintf(fid,'#SBATCH -o %s.outlog \n',modelname);
+			fprintf(fid,'#SBATCH -e %s.errlog \n\n',modelname);
+			fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath); %FIXME
+			fprintf(fid,'source $ISSM_DIR/etc/environment.sh\n');       %FIXME
+			fprintf(fid,'cd %s/%s\n\n',cluster.executionpath,dirname);
+			fprintf(fid,'mpiexec -np %i %s/kriging.exe %s %s\n',cluster.nprocs(),cluster.codepath,[cluster.executionpath '/' modelname],modelname);
+			if ~io_gather, %concatenate the output files:
+				fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+			end
+			fclose(fid);
+		end
+		%}}}
+		function BuildQueueScript(cluster,dirname,modelname,solution,io_gather,isvalgrind,isgprof,isdakota,isoceancoupling) % {{{
 
-			 if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
-			 if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
+			if(isvalgrind), disp('valgrind not supported by cluster, ignoring...'); end
+			if(isgprof),    disp('gprof not supported by cluster, ignoring...'); end
 
-			 %write queuing script 
-			 fid=fopen([modelname '.queue'],'w');
-			 fprintf(fid,'#!/bin/bash\n');
-			 fprintf(fid,'#SBATCH --job-name=%s\n',modelname);
-			 fprintf(fid,'#SBATCH -p %s \n',cluster.queue);
-			 fprintf(fid,'#SBATCH -N %i -n %i\n',cluster.numnodes,cluster.cpuspernode);
-			 fprintf(fid,'#SBATCH --time=%i\n',cluster.time*60); %walltime is in seconds.
-			 fprintf(fid,'#SBATCH --mem-per-cpu=%igb\n',cluster.memory);
-			 fprintf(fid,'#SBATCH -o %s.outlog \n',modelname);
-			 fprintf(fid,'#SBATCH -e %s.errlog \n\n',modelname);
-			 fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath); %FIXME
-			 fprintf(fid,'source $ISSM_DIR/etc/environment.sh\n');       %FIXME
-			 fprintf(fid,'cd %s/%s\n\n',cluster.executionpath,dirname);
-			 fprintf(fid,'mpiexec -n %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
-			 if ~io_gather, %concatenate the output files:
-				 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
-			 end
-			 fclose(fid);
+			%write queuing script 
+			fid=fopen([modelname '.queue'],'w');
+			fprintf(fid,'#!/bin/bash\n');
+			fprintf(fid,'#SBATCH --job-name=%s\n',modelname);
+			fprintf(fid,'#SBATCH --partition=%s',cluster.queue{1});
+			for i=2:length(cluster.queue) 
+				fprintf(fid,',%s',cluster.queue{i});
+			end
+			fprintf(fid,'\n');
+			%fprintf(fid,'#SBATCH -N %i -n %i\n',cluster.numnodes,cluster.cpuspernode);
+			%fprintf(fid,'#SBATCH --mem-per-cpu=%igb\n',cluster.memory);
+			fprintf(fid,'#SBATCH --nodes=%i\n',cluster.numnodes); % in general, just 1
+			fprintf(fid,'#SBATCH --ntasks=%i\n',cluster.cpuspernode); % in general, just 1
+			fprintf(fid,'#SBATCH --cpus-per-task=%i\n',1); 
+			fprintf(fid,'#SBATCH --mem=%igb\n',cluster.memory); % minimum total node memory required
+			fprintf(fid,'#SBATCH --time=%s\n',datestr(cluster.time/24,'HH:MM:SS')); %walltime is in HH:MM:SS format. cluster.time is in hour
+			fprintf(fid,'#SBATCH -o %s.outlog \n',modelname);
+			fprintf(fid,'#SBATCH -e %s.errlog \n\n',modelname);
+			fprintf(fid,'export ISSM_DIR="%s/../"\n',cluster.codepath); %FIXME
+			fprintf(fid,'source $ISSM_DIR/etc/environment.sh\n');       %FIXME
+			fprintf(fid,'cd %s/%s\n\n',cluster.executionpath,dirname);
+			fprintf(fid,'mpiexec -n %i %s/issm.exe %s %s %s\n',cluster.nprocs(),cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+			if ~io_gather, %concatenate the output files:
+				fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+			end
+			fclose(fid);
 
-			 %in interactive mode, create a run file, and errlog and outlog file
-			 if cluster.interactive,
-				 fid=fopen([modelname '.run'],'w');
-				 fprintf(fid,'mpiexec -n %i %s/issm.exe %s %s %s\n',cluster.np,cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
-				 if ~io_gather, %concatenate the output files:
-					 fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
-				 end
-				 fclose(fid);
-				 fid=fopen([modelname '.errlog'],'w');
-				 fclose(fid);
-				 fid=fopen([modelname '.outlog'],'w');
-				 fclose(fid);
-			 end
-		 end %}}}
-		 function UploadQueueJob(cluster,modelname,dirname,filelist)% {{{
+			%in interactive mode, create a run file, and errlog and outlog file
+			if cluster.interactive,
+				fid=fopen([modelname '.run'],'w');
+				fprintf(fid,'mpiexec -n %i %s/issm.exe %s %s %s\n',cluster.nprocs(),cluster.codepath,solution,[cluster.executionpath '/' dirname],modelname);
+				if ~io_gather, %concatenate the output files:
+					fprintf(fid,'cat %s.outbin.* > %s.outbin',modelname,modelname);
+				end
+				fclose(fid);
+				fid=fopen([modelname '.errlog'],'w');
+				fclose(fid);
+				fid=fopen([modelname '.outlog'],'w');
+				fclose(fid);
+			end
+		end %}}}
+		function UploadQueueJob(cluster,modelname,dirname,filelist) % {{{
 
-			 %compress the files into one zip.
-			 compressstring=['tar -zcf ' dirname '.tar.gz '];
-			 for i=1:numel(filelist),
-				 compressstring = [compressstring ' ' filelist{i}];
-			 end
-			 if cluster.interactive,
-				 compressstring = [compressstring ' ' modelname '.errlog ' modelname '.outlog '];
-			 end
-			 system(compressstring);
+			%compress the files into one zip.
+			compressstring=['tar -zcf ' dirname '.tar.gz '];
+			for i=1:numel(filelist),
+				compressstring = [compressstring ' ' filelist{i}];
+			end
+			if cluster.interactive,
+				compressstring = [compressstring ' ' modelname '.errlog ' modelname '.outlog '];
+			end
+			system(compressstring);
 
-			 disp('uploading input file and queueing script');
-			 issmscpout(cluster.name,cluster.executionpath,cluster.login,cluster.port,{[dirname '.tar.gz']});
+			disp('uploading input file and queueing script');
+			issmscpout(cluster.name,cluster.executionpath,cluster.login,cluster.port,{[dirname '.tar.gz']});
 
-		 end %}}}
-		 function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch)% {{{
+		end %}}}
+		function LaunchQueueJob(cluster,modelname,dirname,filelist,restart,batch) % {{{
 
-			 disp('launching solution sequence on remote cluster');
-			 if ~isempty(restart)
-				 launchcommand=['cd ' cluster.executionpath ' && cd ' dirname ' && hostname && sbatch ' modelname '.queue '];
-			 else
-				 launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
-					 ' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && hostname && sbatch ' modelname '.queue '];
-			 end
-			 issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
-		 end %}}}
-		 function Download(cluster,dirname,filelist)% {{{
+			disp('launching solution sequence on remote cluster');
+			if ~isempty(restart)
+				launchcommand=['cd ' cluster.executionpath ' && cd ' dirname ' && hostname && sbatch ' modelname '.queue '];
+			else
+				launchcommand=['cd ' cluster.executionpath ' && rm -rf ./' dirname ' && mkdir ' dirname ...
+					' && cd ' dirname ' && mv ../' dirname '.tar.gz ./ && tar -zxf ' dirname '.tar.gz  && hostname && sbatch ' modelname '.queue '];
+			end
+			issmssh(cluster.name,cluster.login,cluster.port,launchcommand);
+		end %}}}
+		function Download(cluster,dirname,filelist) % {{{
 
-			 %copy files from cluster to current directory
-			 directory=[cluster.executionpath '/' dirname '/'];
-			 issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
+			%copy files from cluster to current directory
+			directory=[cluster.executionpath '/' dirname '/'];
+			issmscpin(cluster.name,cluster.login,cluster.port,directory,filelist);
 
-		 end %}}}
+		end %}}}
 	end
 end
